<?php // -*- coding: latin-9 -*-

require_once(PHPWEATHER_BASE_DIR . '/output/pw_text.php');

/**
 * Provides all the strings needed by pw_text to produce Turkish
 * output.
 *
 * @author   Ferhat Bingol <s021183@student.dtu.dk>
 * @version  pw_text_en.php,v 1.9 2002/10/20 15:57:15 gimpster Exp
 */
class pw_text_tr extends pw_text {

  /**
   * This constructor provides all the strings used.
   *
   * @param  array  This is just passed on to pw_text().
   */
  function pw_text_tr($weather, $input = array()) {
    $this->strings['charset']                  = 'ISO-8859-9';
    $this->strings['no_data']                  = 'zgnz! %s%s%s iin veri bulunmuyor.';
    $this->strings['list_sentences_and']       = ' ve ';
    $this->strings['list_sentences_comma']     = ', ';
    $this->strings['list_sentences_final_and'] = ', ve ';
    $this->strings['location']                 = '%s%s%s iin hazrlanan rapor.';
    $this->strings['minutes']                  = ' dakika';
    $this->strings['time_format']              = 'Rapor %s nce saat %s%s%s UTC de hazrlanm.';
    $this->strings['time_minutes']             = 've %s%s%s dakika';
    $this->strings['time_one_hour']            = '%sone%s saat %s';
    $this->strings['time_several_hours']       = '%s%s%s saat %s';
    $this->strings['time_a_moment']            = 'a moment';
    $this->strings['meters_per_second']        = ' metre / saniye';
    $this->strings['miles_per_hour']           = ' mil / saat';
    $this->strings['meter']                    = ' metre';
    $this->strings['meters']                   = ' metre';
    $this->strings['feet']                     = ' feet';
    $this->strings['kilometers']               = ' kilometre';
    $this->strings['miles']                    = ' mil';
    $this->strings['and']                      = ' ve ';
    $this->strings['plus']                     = ' art ';
    $this->strings['with']                     = ' ile ';
    $this->strings['wind_blowing']             = 'Rzgarn esme hz  ';
    $this->strings['wind_with_gusts']          = ' deerine kadar ulaan gust ';
    $this->strings['wind_from']                = ' , yn ';
    $this->strings['wind_variable']            = ' %svariable% ynnde.';
    $this->strings['wind_varying']             = ', %s%s%s (%s%s&deg;%s) ve %s%s%s (%s%s&deg;%s) arasnda deiken';
    $this->strings['wind_calm']                = 'Rzgar %scalm%';
    $this->strings['wind_dir'] = array(
      'kuzey',
      'kuzey/kuzeydou',
      'kuzeydou',
      'bat/kuzeydou',
      'dou',
      'dou/gneydou',
      'gneydou',
      'gney/gneydou',
      'gney',
      'gney/gneybat',
      'gneybat',
      'bat/gneybat',
      'bat',
      'bat/kuzeybat',
      'kuzeybat',
      'kuzey/kuzeybat',
      'kuzey');
    $this->strings['wind_dir_short'] = array(
      'K',
      'KKD',
      'KD',
      'DKD',
      'D',
      'DGD',
      'GD',
      'GGD',
      'G',
      'GGB',
      'GB',
      'BGB',
      'B',
      'BKB',
      'KB',
      'KKB',
      'K');
    $this->strings['wind_dir_short_long'] = array(
      'K'  => 'kuzey',
      'KD' => 'kuzeydou',
      'D'  => 'dou',
      'GDE' => 'gneydou',
      'G'  => 'gney',
      'GB' => 'gneybat',
      'B'  => 'bat',
      'KB' => 'kuzeybat'
      );
    $this->strings['temperature']     = 'Scaklk ';
    $this->strings['dew_point']       = ', mevcut dew-point ';
    $this->strings['altimeter']       = 'Atmosferk basn ';
    $this->strings['hPa']             = ' hPa';
    $this->strings['inHg']            = ' inHg';
    $this->strings['rel_humidity']    = 'Relativ humidity ';
    $this->strings['feelslike']       = 'Hissedilen scaklk ';
    $this->strings['cloud_group_beg'] = 'Bulunan ';
    $this->strings['cloud_group_end'] = '.';
    $this->strings['cloud_clear']     = 'Gkyz %sclear%s.';
    $this->strings['cloud_height']    = ' bulutlarn ykseklii ';
    $this->strings['cloud_overcast']  = 'Gkyz %sovercast% olduu ykselik ';
    $this->strings['cloud_vertical_visibility'] = 'gr mesafesi %svertical visibility% ';
    $this->strings['cloud_condition'] =
      array(
	    'SKC' => 'ak',
	    'CLR' => 'ak',
	    'FEW' => 'az',
	    'SCT' => 'scattered',
	    'BKN' => 'yer yer bulutlu',
	    'OVC' => 'overcast');
    $this->strings['cumulonimbus']     = ' kumulonimbus';
    $this->strings['towering_cumulus'] = ' towering kumulus';
    $this->strings['cavok']            = ' %s altnda bulut bulunmuyor ve kumulonimbus bulutlar yok';
    $this->strings['currently']        = 'u anda ';
    $this->strings['weather']          = 
      array(
	    '-' => ' light',
	    ' ' => ' moderate ',
	    '+' => ' heavy ',
	    'VC' => ' blgede',
	    'PR' => ' ksmi',
	    'BC' => ' patches of',
	    'MI' => ' s',
	    'DR' => ' dk younlukta',
	    'BL' => ' esen',
	    'SH' => ' sanak',
	    'TS' => ' frtna',
	    'FZ' => ' dondurucu',
	    'DZ' => ' iseleyen',
	    'RA' => ' yamur',
	    'SN' => ' kar',
	    'SG' => ' para karl',
	    'IC' => ' buz kristalleri',
	    'PL' => ' buz paral',
	    'GR' => ' dolu',
	    'GS' => ' az dolulu',
	    'UP' => ' bilinmeyen',
	    'BR' => ' sis',
	    'FG' => ' sisli',
	    'FU' => ' paral sisli',
	    'VA' => ' volkanik dumanl',
	    'DU' => ' widespread dust',
	    'SA' => ' kum',
	    'HZ' => ' puslu',
	    'PY' => ' sprey',
	    'PO' => ' well-developed dust/sand whirls',
	    'SQ' => ' bora',
	    'FC' => ' (funnel cloud tornado waterspout)',
	    'SS' => ' kur/kil frtnas');
    $this->strings['visibility'] = 'Gr mesafesi ';
    $this->strings['visibility_greater_than']  = 'deerinden byk  ';
    $this->strings['visibility_less_than']     = 'deerinden dk ';
    $this->strings['visibility_to']            = '  ';
    $this->strings['runway_upward_tendency']   = ' with an %supward%s tendency';
    $this->strings['runway_downward_tendency'] = ' with a %sdownward%s tendency';
    $this->strings['runway_no_tendency']       = ' with %sno distinct%s tendency';
    $this->strings['runway_between']           = 'arasnda ';
    $this->strings['runway_left']              = ' sol';
    $this->strings['runway_central']           = ' merkez';
    $this->strings['runway_right']             = ' sa';
    $this->strings['runway_visibility']        = 'Gr ';
    $this->strings['runway_for_runway']        = ' uak pisti iin ';

    /* We run the parent constructor */
    $this->pw_text($weather, $input);
  }
}

?>